import Fixture from './fixture';
import { FieldTypeSelector } from './property-builders/field-generator';
interface ExtendsFixture {
    extends: (fixture: Fixture<any>) => void;
}
declare type MappedFieldTypeSelector<T, TFieldTypeSelector> = {
    [P in keyof T]: TFieldTypeSelector;
};
declare type DefineFieldsActionParam<T, TFieldTypeSelector> = MappedFieldTypeSelector<T, TFieldTypeSelector> & ExtendsFixture;
export declare type DefineFieldsAction<T, TFieldTypeSelector> = (t: DefineFieldsActionParam<T, TFieldTypeSelector>) => void;
export declare function createFixtureFactory<TFieldSelectorExtension>(...extensions: any[]): <T>(defineFields: DefineFieldsAction<T, FieldTypeSelector & TFieldSelectorExtension>) => Fixture<T>;
export declare function defineFixtureFactory<TFieldSelectorExtension>(...extensions: any[]): <T>(defineFields: DefineFieldsAction<T, FieldTypeSelector & TFieldSelectorExtension>) => Fixture<T>;
export declare function defineFixture<T>(defineFields: DefineFieldsAction<T, FieldTypeSelector>): Fixture<T>;
export {};
